#include "renderbase.hpp"
#include <iostream>

RenderBase::RenderBase()
{
    orig_width  = 0;
    orig_height = 0;
}

// See: SDL_PixelFormat
#define CURRENT_RGB() (0xff << 24) | (r << 16) | (g << 8) | (b << 0);

void RenderBase::convert_palette(uint32_t adr, uint32_t r, uint32_t g, uint32_t b)
{
    adr >>= 1;

    r = r * 255 / 31;
    g = g * 255 / 31;
    b = b * 255 / 31;

    rgb[adr] = CURRENT_RGB();
      
    // Create shadow / highlight colours at end of RGB array
    // The resultant values are the same as MAME
    r = r * 202 / 256;
    g = g * 202 / 256;
    b = b * 202 / 256;
        
    rgb[adr + S16_PALETTE_ENTRIES] =
    rgb[adr + (S16_PALETTE_ENTRIES * 2)] = CURRENT_RGB();
}